import os
import sys
import tempfile
import json
# import argparse
import azureml
from azureml.core import Workspace, Experiment, Environment
from azureml.core.compute import ComputeTarget
from azureml.core import ScriptRunConfig, RunConfiguration
from azureml.core.runconfig import DockerConfiguration
from azureml.contrib.core.gjdrunconfig import GlobalJobDispatcherConfiguration
from azureml.core.conda_dependencies import CondaDependencies  # from azureml.widgets import RunDetails
from datetime import datetime
def parser():
    import easydict
    args = easydict.EasyDict({
        "use_gjd": True, #True
        "region": "westus2",
        "cpu": False,
        "exp_name": "zhijun_pytorch", #PLC_pytorch/PLC_synthesize/PLC_challenge/PLC_multi_task
        "info": "ar libritts tfcodec 16",
        "nb_repro": 1,
        "train_config": "config.yaml",
        "checkpoint_path": None,
        "checkpoint_dir": None,
    })
    return args

if __name__ == '__main__':
    import argparse
    external_parser = argparse.ArgumentParser(description='Process command line parameters.')
    external_parser.add_argument('--info', type=str, default="baseline",
                        help='info of experiments')
    external_parser.add_argument('--config', type=str, default=None,
                        help='config')
    ext_args = external_parser.parse_args()
    info = ext_args.info
    exp_config = ext_args.config
    args = parser()
    args.info = "generate accent dataset"
    DATASTORE_DICT = {"packet_loss_concealment": 'zhijun_data'} # datastore need to be registered first on the workspace
    REGION_DICT = {"westus2": 'packet_loss_concealment'}
    VC_DICT = {"packet_loss_concealment": 'Westus2.PacketLossConcealment2',}
    workspace_name = REGION_DICT[args.region]
    datastore_name = DATASTORE_DICT[workspace_name]
    vc_name = VC_DICT[workspace_name]
    
    # from azureml.core.authentication import InteractiveLoginAuthentication
    # InteractiveLoginAuthentication(force=True)
    # init workspace
    ws = Workspace(
        subscription_id="f1f491ac-0340-4e5d-87b7-47692be1cb31",
        resource_group="IC3_Common_GPU_cluster",
        workspace_name=workspace_name
    )
    # increase shared memory. NB: must be set before the env def
    # azureml.core.environment._DEFAULT_SHM_SIZE = '10000g'  # enlarge for lmdb
    # # init environment
    # env = Environment.get(ws, "valle-4-23-noconda-v2")
    env = Environment(name="valle-4-23-noconda-v9")
    env.docker.enabled = True
    # # env.docker.base_image = "1294582975/valle-4-23-noconda:v0" #"huxue-pytorch1.7-cuda11-python3.7
    env.docker.base_image = "jiazhijun/valle-4-23-noconda:v9" #"huxue-pytorch1.7-cuda11-python3.7
    env.docker.base_image_registry.address = 'msrresrchcr.azurecr.io' #"ic3aicommonpoolregistry.azurecr.io"
    env.docker.base_image_registry.username = 'msrresrchcr' #"ic3aicommonpoolregistry" #service_principal_id # in order to push
    # env.docker.base_image_registry.password = '' #"${TVFCKXng/8L+Y7gX2C8wRk68j41YYksrDWE0lm2OEL+ACRDF23+Y}"
    env.docker.base_image_registry.password = "VNaA+VSV0v8S+u5k6qcrBgz4FfepnEuMinm/bINT9j+ACRCzBz0+"
    # specifying your own Python interpreter:
    # https://docs.microsoft.com/en-us/azure/machine-learning/how-to-use-environments#specify-your-own-python-interpreter
    env.python.user_managed_dependencies = True
    # env.python.interpreter_path = "/usr/bin/python3"
    env.python.interpreter_path = "/opt/conda/bin/python"
    env.register(workspace=ws)
    env.build(ws)
    # import pdb; pdb.set_trace()
    # Setup the run_config using a dict
    run_config_struct = dict()
    run_config_struct["node_count"] = 1
    run_config_struct["environment"] = env._serialize_to_dict(env)
    run_config_struct["target"] = " "
    if not args.use_gjd:
        run_config_struct["target"] = "evalNC24" if args.cpu else "PrimaryTrain"
    # Serialize the dict to json file
    project_dir = tempfile.mkdtemp()
    os.makedirs(os.path.join(project_dir, ".amlcompute"))
    run_config_path = os.path.join(project_dir, ".amlcompute", "simple.runconfig")
    with open(run_config_path, "w") as outfile:
        json.dump(run_config_struct, outfile)
    run_config = RunConfiguration.load(run_config_path)
    #docker
    run_config.docker = DockerConfiguration(use_docker=True, shared_volumes=True, shm_size='2000g')
    # get cluster
    if args.use_gjd:   # Enable global job dispatcher to leverage idle compute resources from other workspaces
        # vc_list = ["Microsoft.IC3.PrimaryTrain.{}".format(vc_name)]
        vc_list = ["Microsoft.IC3.Unified.Westus2.{}".format(vc_name)]
        run_config.global_job_dispatcher = GlobalJobDispatcherConfiguration(compute_type="Amlcompute",
                                                                                   region=[],
                                                                                   vc_block_list=vc_list)
        compute_target = None
    elif args.cpu:  # Only use a specific node in a single workspace
        compute_target = "evalNC24" #ws.compute_targets["evalNC24"] #ComputeTarget(workspace=ws, name="evalNC24")
    else:
        compute_target = "PrimaryTrain" #ComputeTarget(workspace=ws, name="PrimaryTrain")
    # compute_target = ComputeTarget(workspace=ws, name="evalNC24")
    # print(compute_target)

      #     --manifest-dir /mnt/shared/LibriTTS/data_valle/data/tokenized/ 
      # --text-tokens /mnt/shared/LibriTTS/data_valle/data/tokenized/unique_text_tokens.k2symbols 
      # --exp-dir /mnt/shared/LibriTTS/data_valle/data/output/$${dir_name}_$${basestr}
       #---------PLC data------------
    # data_ref = ws.datastores[datastore_name].path("PLC/data_folder/PLC/tfrecord_4s_half_frm_pl_JBC_lmdb_2/librivox600hrs_random_pl_10_20_30_40_50_markov_0_train_399_20.0ms_shift_10.0ms_drop_0.0ms.lmdb").as_mount() # for offline data    
    # val_ref = ws.datastores[datastore_name].path("PLC/data_folder/PLC/tfrecord_4s_half_frm_pl_JBC_lmdb_2/val_librivox600hrs_random_pl_10_20_30_40_50_markov_0_train_2999_20.0ms_shift_10.0ms_drop_0.0ms.lmdb").as_mount() # for offline data
    # data_ref = ws.datastores[datastore_name].path("librivox600hrs_random_pl_10_20_30_40_50_markov_0_train_399_20.0ms_shift_10.0ms_drop_0.0ms.lmdb").as_mount() # for offline data    
    # val_ref = ws.datastores[datastore_name].path("val_librivox600hrs_random_pl_10_20_30_40_50_markov_0_train_2999_20.0ms_shift_10.0ms_drop_0.0ms.lmdb").as_mount() # for offline data
    # train_ref = ws.datastores[datastore_name].path("hesam_train/tfnetv4_baseline_reproduce").as_mount()
    
    name="VALLE"  
    max_duration=50  
    dtype="float32"  
    base_lr=0.05
    world_size=8
    echo=2
    train_stage=1
    start_epoch=1
    current_time = datetime.now()
    timestamp = current_time.strftime("%Y_%m_%d_%H_%M_%S")
    accumulate_grad_steps=1
    prefix_mode=1
    input_semantic = "True"
    only_autoregressive = "True"
    num_quantizers = 16 # if target is semantic , num_quantizer is set to 1

    semantic_remove = "True"
    sheduler_steps=40
    sheduler_epochs=4
    
    semantic_depup="False"
    top_k = 50
    random_tgt_spk = "False"
    tgt_spk_name = "cmu_us_bdl_arctic"

    input_codec = 1
    dir_name=f"generate_dataset_in_codec_{input_codec}_tk_{top_k}" 
    
# https://resrchvc4data.blob.core.windows.net/v-zhijun/data/l1_l2_arctic/lhotse_data_vc/tokenized/tokenized_24k_layer9/cuts_dev.jsonl.gz
    exp_dir = ws.datastores[datastore_name].path(f"data/l1_l2_arctic/lhotse_data_vc_target_semantic_native_all_accents/output_semantic/{dir_name}_{timestamp}").as_mount()

    ref_tokens_path = ws.datastores[datastore_name].path(f"data/semantic_acoustic_tokens_dic/libritts_clean_100_acoustic_semantic.json").as_mount()
    current_time = datetime.now()
    timestamp = current_time.strftime("%Y_%m_%d_%H_%M_%S")

    manifest_dir = ws.datastores[datastore_name].path("data/l1_l2_arctic/lhotse_data_vc_target_semantic_native/tokenized").as_mount()
    text_tokens = ws.datastores[datastore_name].path("data/l1_l2_arctic/lhotse_data_vc_target_semantic_native/tokenized/unique_text_tokens.k2symbols").as_mount()
    semantic_tokens = ws.datastores[datastore_name].path("data/l1_l2_arctic/lhotse_data_vc_target_semantic_native/tokenized/unique_semantic_tokens.k2symbols").as_mount()

    output_dir = ws.datastores[datastore_name].path("data/l1_l2_arctic/lhotse_data_vc_target_semantic_native/generate_data").as_mount()
    checkpoint = ws.datastores[datastore_name].path("data/LibriTTS/lhotse_vc/output_vc/linear_Name_VALLE_m-duration_50_dtype_float32_b-lr_0.05_t-stage_1_echo_20_s_echo_1_p_mode_1_i_semantic_True_o_ar_True_n_quantizers_16_s_steps_5000_s_epochs_4_a_grad_steps_4_s_depup_False_s_linear_True_2023_08_18_14_10_20/epoch-64.pt").as_mount()
    config_path = ws.datastores[datastore_name].path("models/tfnet/config_6k_tfnetv2_20msvq_hop5_combine4_rd_multi_lingual.yaml").as_mount()
    tfnet_ckpt = ws.datastores[datastore_name].path("models/tfnet/890hrs16khz_tfnet_v2i_vqvae_20msVQ_hop5_combine4_rd1_6kbps/tfnet_v2i_vqvae_combineVQ-iter-514000-val1-0.348327-entropy-118.968-mel-0.067548-recon-0.012822.ckpt").as_mount()


    warmup_ref = None
    # ckpt_ref = ws.datastores[datastore_name].path("${pretrained_ckpt_path}").as_mount()
    ckpt_ref = None
    checkpoint_dir_ref=None
     
    print(f"timestamp : {timestamp}")
    arg_list = [
        "--nproc-per-node", world_size,
        "--nnodes", 1,        
        "--max-duration", max_duration,
        "--filter-min-duration", 0.5,
        "--filter-max-duration", 14,
        "--train-stage", train_stage,
        "--num-buckets", 6,
        "--dtype", dtype,
        "--save-every-n", 20000000000,
        "--log-interval", 20,
        "--valid-interval", 40,   
        "--model-name", "valle",
        "--share-embedding", True,  
        "--norm-first", True,  
        "--add-prenet", False,  
        "--decoder-dim", 1024,  
        "--nhead", 16,  
        "--num-decoder-layers", 12,
        "--num-quantizers", num_quantizers,  
        "--prefix-mode", prefix_mode,  
        "--base-lr", base_lr,  
        "--warmup-steps", 20,  
        "--average-period", 0,  
        "--num-epochs", echo,  
        "--start-epoch", start_epoch,  
        "--start-batch", 0,  
        "--accumulate-grad-steps",accumulate_grad_steps,  
        "--world-size", world_size,
        "--manifest-dir", str(manifest_dir),
        "--text-tokens", str(text_tokens),
        "--semantic-tokens", str(semantic_tokens),
        "--exp-dir", str(exp_dir),
        "--newfile-suffix", str(timestamp),
        "--is-local", False,
        "--input-semantic", str(input_semantic),
        "--only-autoregressive", str(only_autoregressive),
        "--sheduler-steps", sheduler_steps,
        "--sheduler-epochs", sheduler_epochs,
        "--output-dir", str(output_dir),
        "--checkpoint", str(checkpoint),
        "--is-local", "False" ,
        "--shared-linear", "True",
        "--ref-tokens-path", str(ref_tokens_path),
        "--config-path", str(config_path),
        "--tfnet-ckpt", str(tfnet_ckpt),
        "--input-codec", 1,
        "--top-k", top_k

    ]
    # estimator
    src_dir = "./" # parent dir
    estimator = ScriptRunConfig(
        source_directory=src_dir,
        script="egs/libritts/bin/multiprocess_caller_generate_dataset.py",
        run_config=run_config,
        arguments=arg_list,
        compute_target=compute_target,
    )
    estimator.run_config.target = " "
    estimator.run_config.data_references[manifest_dir.data_reference_name] = manifest_dir.to_config()
    estimator.run_config.data_references[text_tokens.data_reference_name] = text_tokens.to_config()
    estimator.run_config.data_references[semantic_tokens.data_reference_name] = semantic_tokens.to_config()

    estimator.run_config.data_references[exp_dir.data_reference_name] = exp_dir.to_config()
    estimator.run_config.data_references[output_dir.data_reference_name] = output_dir.to_config()
    estimator.run_config.data_references[checkpoint.data_reference_name] = checkpoint.to_config()
    estimator.run_config.data_references[ref_tokens_path.data_reference_name] = ref_tokens_path.to_config()
    # create experiment
    estimator.run_config.data_references[config_path.data_reference_name] = config_path.to_config()
    estimator.run_config.data_references[tfnet_ckpt.data_reference_name] = tfnet_ckpt.to_config()


    exp = Experiment(workspace=ws, name=args.exp_name)
    

    # submit a run
    for i in range(args.nb_repro):
        info_tag = {"info": "{} r{}".format(args.info, i)}
        run = exp.submit(estimator, tags=info_tag)
        # RunDetails(run).show()
        print(run.get_details())
        # last_run = list(exp.get_runs())[0]  
